import { useEffect, useState } from 'react';
import cx from 'classnames';
import PropTypes from 'prop-types';
import Chevronbottom from '@s-ui/react-icons/lib/Chevronbottom';
import { jsx as _jsx } from "react/jsx-runtime";
import { jsxs as _jsxs } from "react/jsx-runtime";
var ANIMATION_SPEED_CLASSNAMES = {
  normal: 'sui-CollapsibleBasic-transitionNormal',
  fast: 'sui-CollapsibleBasic-transitionFast'
};
var CollapsibleBasic = function CollapsibleBasic(_ref) {
  var animationSpeed = _ref.animationSpeed,
    children = _ref.children,
    collapsed = _ref.collapsed,
    onClick = _ref.handleClick,
    hideTriggerIcon = _ref.hideTriggerIcon,
    ArrowIcon = _ref.icon,
    isClickable = _ref.isClickable,
    label = _ref.label;
  var _useState = useState(collapsed),
    isCollapsed = _useState[0],
    setIsCollapsed = _useState[1];
  useEffect(function () {
    setIsCollapsed(collapsed);
  }, [collapsed]);
  var handleClick = function handleClick() {
    var nextIsCollapsed = !isCollapsed;
    setIsCollapsed(nextIsCollapsed);
    onClick(nextIsCollapsed);
  };
  var cssClassNames = cx('sui-CollapsibleBasic', {
    'is-collapsed': isCollapsed,
    'is-expanded': !isCollapsed
  });
  var contentCssClassNames = cx('sui-CollapsibleBasic-collapsibleContent', ANIMATION_SPEED_CLASSNAMES[animationSpeed]);
  return /*#__PURE__*/_jsxs("div", {
    className: cssClassNames,
    children: [/*#__PURE__*/_jsxs("div", {
      className: "sui-CollapsibleBasic-trigger",
      onClick: isClickable ? handleClick : undefined,
      children: [/*#__PURE__*/_jsx("div", {
        className: "sui-CollapsibleBasic-trigger-label",
        children: label
      }), !hideTriggerIcon && /*#__PURE__*/_jsx("div", {
        className: "sui-CollapsibleBasic-trigger-iconBox",
        children: /*#__PURE__*/_jsx(ArrowIcon, {
          svgClass: "sui-CollapsibleBasic-trigger-iconBox-icon",
          className: "sui-CollapsibleBasic-trigger-iconBox-icon"
        })
      })]
    }), /*#__PURE__*/_jsx("div", {
      className: contentCssClassNames,
      children: children
    })]
  });
};
CollapsibleBasic.displayName = 'CollapsibleBasic';
CollapsibleBasic.defaultProps = {
  icon: Chevronbottom,
  collapsed: true,
  hideTriggerIcon: false,
  animationSpeed: 'normal',
  isClickable: true,
  handleClick: function handleClick() {}
};
export default CollapsibleBasic;